<?php

namespace App\Http\Controllers\Admin;

/** Ajax Request */

use App\Exports\MemberExport;
use App\Http\Requests\Admin\WorkDayRequest;
use App\Models\Volunteer;
use App\Services\Interfaces\CategoryRepositoryInterface;
use App\Services\Response\ResponseService;
use Exception;
use Illuminate\View\View;
use Illuminate\Http\Request;
use Illuminate\Http\JsonResponse;
use Illuminate\Routing\Redirector;
use Illuminate\Http\RedirectResponse;
use App\Http\Controllers\Controller;
use Maatwebsite\Excel\Facades\Excel;

class VolunteerController extends Controller
{

    /** Redirect to this path after each operation success*/
    private $redirectSuccessPath= '/admin/volunteers';
    /** View folder */
    private $viewDirectory= 'admin.volunteers.';
    //
    private CategoryRepositoryInterface $volunteerRepository;

    public function __construct(CategoryRepositoryInterface $volunteerRepository)
    {
        $this->volunteerRepository = $volunteerRepository;
    }

    /**
     * Display a listing of the volunteers.
     *
     * @param Request $request
     * @return View
     */
    public function index(Request $request) :View
    {
        $title= __('volunteers.head');
        return view($this->viewDirectory.'index', get_defined_vars());
    }

    /**
     * return data of the volunteers.
     *
     * @param Request $request
     * @return View
     */
    public function grid(Request $request) //:View
    {
        $request->merge(['all_info'=> true]);
        if (isset($request->export)) {
            $volunteers= $this->volunteerRepository->get($request);
            return Excel::download(new VolunteerExport($volunteers, 'volunteers'), 'Volunteers.xlsx');
        }

        $request->merge(['paginate'=> true]);
        $volunteers= $this->volunteerRepository->get($request);

        return view($this->viewDirectory.'grid',compact('volunteers'));
    }

    /**
     * Show the form for creating a new Volunteer.
     *
     * @return View
     */
    public function create() :View
    {
        $action= route('volunteers.store');
        $head= __('volunteers.new');
        return view( $this->viewDirectory.'form', get_defined_vars() );
    }

    /**
     * Store a newly created Volunteer in storage.
     * @param WorkDayRequest $request
     * @return RedirectResponse|Redirector
     */
    public function store(WorkDayRequest $request) :JsonResponse
    {
        $volunteer= $this->volunteerRepository->save($request, null);

        session()->flash('message', __('dashboard.saveDone'));
        $response = [
            'status'=>200,
            'message'=>__('web.success'),
            'data'=> route('volunteers.index'),
        ];
        return ResponseService::response($response);
    }

    /**
     * Show the form for editing the specified Volunteer.
     *
     * @param  Volunteer  $volunteer
     * @return View
     */
    public function edit(Volunteer $volunteer) :View
    {
        // dd($volunteer->id);
        $action= route('volunteers.update', $volunteer->id);
        $head= __('volunteers.edit');
        return view( $this->viewDirectory.'form', get_defined_vars() );
    }

    /**
     * Update the specified Volunteer in storage.
     * @param WorkDayRequest $request
     * @param Volunteer $volunteer
     * @return RedirectResponse|Redirector
     */
    public function update(WorkDayRequest $request, Volunteer $volunteer) :JsonResponse
    {
        $volunteer= $this->volunteerRepository->save($request, $volunteer);
        session()->flash('message', __('dashboard.saveDone'));
        $response = [
            'status'=>200,
            'message'=>__('web.success'),
            'data'=> route('volunteers.index'),
        ];
        return ResponseService::response($response);
    }

    /**
     * Remove the specified Volunteer from storage.
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     * @throws Exception
     */
    public function destroy(Request $request, int $id) :JsonResponse
    {
        $return= $this->volunteerRepository->destroy($request, $id);
        return response()->json($return[0], $return[1] ?? 200);
    }

    /**
     * Remove several volunteers by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function destroyAll(Request $request) :JsonResponse
    {
        $return= $this->volunteerRepository->destroyAll($request);
        return response()->json($return[0], $return[1] ?? 200);
    }

    /**
     * Restore the specified Volunteer from storage.
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     */
    public function restore(Request $request, int $id) :JsonResponse
    {
        $return= $this->volunteerRepository->restore($request, $id);
        return response()->json($return[0], $return[1] ?? 200);
    }

    /**
     * Restore several volunteers by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function restoreAll(Request $request) :JsonResponse
    {
        $return= $this->volunteerRepository->restoreAll($request);
        return response()->json($return[0], $return[1] ?? 200);
    }
}
